<?php
namespace EMS\PortalFuncionario\Geral\Repository;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

class PeriodoApuracaoRepository extends Crud {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getPeriodoByNrperiodoapuracao(
        $nrorg,
        $nrperiodoapuracao
    ) : array {
        try {
            $sql = <<<SQL
                SELECT PPA.NRPERIODOAPURACAO,
                    TO_CHAR(PPA.DTINICIALAPURACAO, 'DD/MM/YYYY')||' - '||TO_CHAR(PPA.DTFINALAPURACAO, 'DD/MM/YYYY')||
                    ' ('||PPA.IDPERIODOAPURACAO||')'                AS DSPERIODOAPURACAO,
                    PPA.NRORG,
                    TO_CHAR(PPA.DTFINALAPURACAO, 'DD/MM/YYYY')      AS DTFINALAPURACAO, 
                    TO_CHAR(PPA.DTINICIALAPURACAO, 'DD/MM/YYYY')    AS DTINICIALAPURACAO, 
                    PPA.NRTIPOPERIODOAPURACAO, 
                    PPA.IDPERIODOAPURACAO
                FROM PTO_PERIODOAPURACAO PPA
                WHERE PPA.NRORG                 = :P_NRORG
                      AND PPA.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
SQL;

            $query = $this->entityManager->getConnection()->prepare($sql);

            $query->execute(
                array(
                    "P_NRORG"               => $nrorg,
                    "P_NRPERIODOAPURACAO"   => $nrperiodoapuracao
                )
            );

            return $query->fetch();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
}